<template>
  <div class="airportInfo scroll-y">
    <div class="wrap">
      <Minheader
        :is-auth="true"
        :is-statuser="true"
        powerData="position_addition_button"
        @addForm="addForm"
      >
        <template #header>
          <div class="status flex-wrap">
            <div class="manageTitle">位置设置</div>
          </div>
        </template></Minheader
      >
      <div class="app-containers">
        <DataTable
          :tableHeader="tableCols"
          :tableData="tableData"
          :tableBtnGroup="tableBtnGroup"
          :tableProperty="{ rowKey: 'ID' }"
          @btnClick="btnClick"
        />
      </div>
      <Dialog
        :flag="flag"
        :type="type"
        :msgTitle="msgTitle"
        :delName="tableForm.positionDescribe"
        @resetForm="resetForm"
        @delRest="delRest"
        @submitForm="submitForm"
        @delRemove="delRemove"
      >
        <div class="diacont">
          <el-form
            :model="tableForm"
            :rules="formRules"
            ref="positionSettingForm"
          >
            <el-row :gutter="24">
              <!-- <el-col>
                <el-form-item
                  label="区域ID"
                  size="default"
                  prop="terminalID"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    disabled
                    v-model="tableForm.terminalID"
                    placeholder="请输入区域ID"
                  />
                </el-form-item>
              </el-col> -->
              <el-col>
                <el-form-item
                  label="区域名称"
                  size="default"
                  prop="terminalName"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    disabled
                    v-model="tableForm.terminalName"
                    placeholder="请输入区域名称"
                  />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item
                  label="位置名称"
                  size="default"
                  prop="positionDescribe"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.positionDescribe"
                    placeholder="请输入位置名称"
                  />
                </el-form-item>
              </el-col>
              <!-- <el-col>
                <el-form-item
                  label="位置序号"
                  size="default"
                  prop="positionSN"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.positionSN"
                    placeholder="请输入位置序号"
                  />
                </el-form-item>
              </el-col> -->
              <el-col>
                <el-form-item
                  label="位置编码"
                  size="default"
                  prop="locationCode"
                  :rules="formRules.isNotNull"
                >
                  <el-input
                    v-model="tableForm.locationCode"
                    placeholder="请输入位置编码"
                  />
                </el-form-item>
              </el-col>
              <el-col :span="24">
                <el-form-item label="备注" size="default">
                  <el-input
                    type="textarea"
                    v-model="tableForm.remarks"
                    placeholder="请输入备注"
                  />
                </el-form-item>
              </el-col>
              <!-- <el-col>
                <el-form-item label="位置英文描述" size="default">
                  <el-input
                    v-model="tableForm.englishDescribe"
                    placeholder="请输入位置英文描述"
                  />
                </el-form-item>
              </el-col> -->
            </el-row>
          </el-form>
        </div>
      </Dialog>
    </div>
  </div>
</template>
<script setup lang="ts">
import DataTable from "@/components/tableTemp/index.vue";
import Minheader from "@/components/minheader/index.vue";
import Dialog from "@/components/dialog/index.vue";
import { Query, GeneralDataReception } from "@/api/webApi";
import { ElMessage } from "element-plus";
const formRules = useElement().formRules;
const route = useRoute();
const page = ref<number>(0); //分页参数
const dataContent = ref<object>({});
const noMore = ref<Boolean>(false);
const rowTitle = ref<String>("");
const tableCols = ref([]); //表头数据
const serviceId = ref<String>("");
const tableObj = ref({}); //增删改数据缓存
const flag = ref<Boolean>(false); //弹窗开关
const type = ref<String>(""); //判断是否删除
const msgTitle = ref<String>("新增位置设置"); //弹窗标题
const tableColsCopys = reactive<Object>({}); //弹窗
const tableForm = reactive({
  positionID: "",
  positionSN: "",
  positionDescribe: "",
  englishDescribe: "",
  locationCode: "",
  terminalID: "",
  terminalName: "",
  remarks: "",
  event: "",
}); //弹窗内容
//列表
tableForm.terminalID = route.query.terminalID;
tableForm.terminalName = route.query.terminalName;
const tableData = ref([]);
//表头
const state = reactive({
  list: [
    { label: "位置名称", key: "name" },
    { label: "位置所属节点", key: "china" },
    { label: "位置标识", key: "englin" },
    { label: "位置编码", key: "two" },
    { label: "位置描述", key: "three" },
  ],
  listLoading: true,
});
const tableBtnGroup = ref([
  {
    name: "编辑",
    className: "editBtn",
    param: 2,
    is: "position_edit_button",
  },
  {
    name: "删除",
    className: "delBtn",
    param: 3,
    is: "location_delete_button",
  },
]);
//新增
const addForm = () => {
  msgTitle.value = "新增位置";
  tableForm.event = 1;
  flag.value = true;
  type.value = "";
};
//取消
const resetForm = () => {
  flag.value = false;
  tableForm.positionID = "";
  tableForm.positionSN = "";
  tableForm.positionDescribe = "";
  tableForm.englishDescribe = "";
  tableForm.locationCode = "";
  tableForm.remarks = "";
};
//删除
const eleDialog = () => {
  msgTitle.value = "删除位置";
  flag.value = true;
  type.value = "del";
};
const delRemove = () => {
  tableForm.event = 3;
  generalDataReception(tableForm);
};
//删除
const delRest = () => {
  flag.value = false;
};
//编辑-删除
const btnClick = (row, index, param) => {
  if (param === 2) {
    msgTitle.value = "编辑位置";
    flag.value = true;
    type.value = "";
    tableForm.event = 2;
    tableForm.positionID = index.positionID;
    tableForm.positionSN = index.positionSN;
    tableForm.positionDescribe = index.positionDescribe;
    tableForm.englishDescribe = index.englishDescribe;
    tableForm.locationCode = index.locationCode;
    tableForm.terminalID = index.terminalID;
    tableForm.remarks = index.remarks;
  } else if (param === 3) {
    msgTitle.value = "删除位置";
    flag.value = true;
    type.value = "del";
    tableForm.event = 3;
    tableForm.positionID = index.positionID;
    tableForm.positionSN = index.positionSN;
    tableForm.positionDescribe = index.positionDescribe;
    tableForm.englishDescribe = index.englishDescribe;
    tableForm.locationCode = index.locationCode;
    tableForm.terminalID = index.terminalID;
  } else if (param === 4) {
  }
};
//获取表格数据
const getQuery = async () => {
  try {
    const { code, returnData } = await Query({
      id: DATACONTENT_ID.airpositTableId,
      needPage: ++page.value,
      dataContent: [route.query.terminalID],
    });
    if (code === "0") {
      if (returnData.listValues.length === 0) {
        page.value--;
        noMore.value = true;
      }
      const titleColumn = returnData.columnSet.find(
        (item) => item.needShow === 1
      );
      if (titleColumn) {
        rowTitle.value = titleColumn.columnName;
      }
      tableData.value.push(...returnData.listValues);
      tableCols.value = returnData.columnSet;
      tableData.value.forEach((element) => {
        element.terminalName = route.query.terminalName;
      });
      tableCols.value.forEach((element) => {
        element.label = element.columnLabel;
        element.key = element.columnName;
        // if (element.columnName === "queryTemplate") {
        //   element.width = "300px";
        // }
      });
      serviceId.value = returnData.submitID;
    } else {
      page.value--;
    }
  } catch (error) {
    page.value--;
  }
};
// //确认提交
// const submitForm = () => {
//   generalDataReception(tableForm);
// };
//确认提交
const positionSettingForm: any = ref(null);
const submitForm = () => {
  positionSettingForm.value.validate((valid: any) => {
    if (valid) {
      generalDataReception(tableForm);
    } else {
      return false;
    }
  });
};
const resetTable = () => {
  page.value = 0;
  noMore.value = false;
  tableData.value = [];
};
//新增-编辑-删除
const generalDataReception = async (data) => {
  try {
    let obj = {
      terminalID: route.query.terminalID,
    };
    data = {
      ...data,
      obj,
    };
    const { code } = await GeneralDataReception({
      serviceId: serviceId.value,
      dataContent: JSON.stringify(data),
    });
    if (code == 0) {
      ElMessage.success(`操作成功`);
      // this.$message.success("操作成功");
      resetTable();
      getQuery();
      resetForm();
      flag.value = false;
      // rmFlag.value = false;
      tableObj.value = {};
      // this.$router.go(0);
    } else {
      ElMessage.error(`操作失败`);
      // this.$message.error("操作失败");
      // this.flag = false;
      // this.rmFlag = false;
      tableObj.value = {};
      resetForm();
    }
  } catch (error) {
    flag.value = false;
    //  rmFlag.value = false;
    tableObj.value = {};
    resetForm();
  }
};
getQuery();
</script>
<style lang="scss" scoped>
::v-deep .el-form-item__label {
  width: 110px;
}
</style>
